// GITVERSION: embed.1-168-g6389bd00
#ifndef EVAL_HPP
#define EVAL_HPP
#include <cassert>
#include <cstdlib>
#include "aedtools/evalbase.hpp"
using namespace std;

namespace aed {

  list<int>::iterator string_to_iterator(list<int> &L, string str) {
    if (str=="begin") return L.begin();
    if (str=="end") return L.end();
    assert(str.find("begin+")==0);
    list<int>::iterator it = L.begin();
    advance(it,atoi(str.substr(6).c_str()));
    return it;
  }
  
  string iterator_to_string(list<int> &L, list<int>::iterator it) {
    if (it==L.end()) return "end";
    int n = std::distance(L.begin(),it);
    if (n==0) return "begin";
    return string("begin+")+to_string(n);
  }
  
  list<int>::iterator my_advance(list<int> &L, int n) {
    list<int>::iterator it = L.begin();
    std::advance(it,n);
    return it;
  }
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  typedef void (*separate_t)(vector<int> &v,vector<int> &even,
                             vector<int> &odd);
  class eval1_t : public eval_base_t {
  public:
    separate_t F;
    eval1_t() { dumptests=0; F=NULL; ejerc=1; testfile="./sep.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v = data["v"], odd,even;
      F(v,even,odd);
      outuser["odd"] = odd;
      outuser["even"] = even;
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      int n=6+rnd.rand()%6;
      vector<int> v;
      for(int i=0;i<n;i++) v.push_back(rnd.rand()%20);
      datain["v"] = v;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  typedef bool (*is_greater_than_t)(vector<int> &v1,vector<int> &v2);
  class eval2_t : public eval_base_t {
  public:
    is_greater_than_t F;
    eval2_t() { dumptests=0; F=NULL; ejerc=2; testfile="./igt.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v1 = data["v1"];
      vector<int> v2 = data["v2"];
      bool ret  = F(v1,v2);
      outuser["ret"] = ret;
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      int nl=3+rnd.rand()%3;
      int n2=3+rnd.rand()%3;
      vector<int> v1,v2;
      for(int i=0;i<nl;i++) v1.push_back(rnd.rand()%4+2);
      for(int i=0;i<n2;i++) v2.push_back(rnd.rand()%4);
      datain["v1"] = v1;
      datain["v2"] = v2;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  typedef int (*max_sum_t)(vector< vector<int> > &vv);
  class eval3_t : public eval_base_t {
  public:
    max_sum_t F;
    eval3_t() { dumptests=0; F=NULL; ejerc=3; testfile="./ms.json"; }
    void run_case(json &data,json &outuser) {
      vector< vector<int> > vv = data["vv"];
      int jmax = F(vv);
      outuser["ret"] = jmax;
    }
    
    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      vector< vector<int> > vv;
      int nv = 3 + rnd.rand()%3;
      vv.resize(nv);
      for (int j=0; j<nv; j++) {
        vector<int> &vj = vv[j];
        int m = rnd.rand()%5;
        for (int k=0; k<m; k++)
          vj.push_back(rnd.rand()%5);
      }
      datain["vv"] = vv;
    }
  };
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  using Eval = eval_t<eval1_t,separate_t,
                      eval2_t,is_greater_than_t,
                      eval3_t,max_sum_t>;
}
#undef CSTR

#endif
