// GITVERSION: texstuff-1.3.2-147-g3ab89aa5
#ifndef EVAL_HPP
#define EVAL_HPP
#include <cassert>
#include <cstdlib>
#include "aedtools/evalbase.hpp"
using namespace std;

namespace aed {

  list<int>::iterator string_to_iterator(list<int> &L, string str) {
    if (str=="begin") return L.begin();
    if (str=="end") return L.end();
    assert(str.find("begin+")==0);
    list<int>::iterator it = L.begin();
    advance(it,atoi(str.substr(6).c_str()));
    return it;
  }
  
  string iterator_to_string(list<int> &L, list<int>::iterator it) {
    if (it==L.end()) return "end";
    int n = std::distance(L.begin(),it);
    if (n==0) return "begin";
    return string("begin+")+to_string(n);
  }
  
  list<int>::iterator my_advance(list<int> &L, int n) {
    list<int>::iterator it = L.begin();
    std::advance(it,n);
    return it;
  }
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  typedef void (*occurm_t)(vector<int> &v,int m,vector<int> &vm);
  class eval1_t : public eval_base_t {
  public:
    occurm_t F;
    eval1_t() { dumptests=0; F=NULL; ejerc=1; testfile="./ocm.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v = data["v"], vm;
      int m = data["m"];
      F(v,m,vm);
      outuser["vm"] = vm;
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      // Nbr of itmes in v
      int n=8+rnd.rand()%8;
      vector<int> v;
      for(int i=0;i<n;i++) v.push_back(rnd.rand()%5);
      datain["v"] = v;
      datain["m"] = 1+rnd.rand()%4;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  typedef void (*subvmax_t)(vector<int>&v, vector<int> &subv);
  class eval2_t : public eval_base_t {
  public:
    subvmax_t F;
    eval2_t() { dumptests=0; F=NULL; ejerc=2; testfile="./svm.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v = data["v"], vmax;
      F(v,vmax);
      outuser["vmax"] = vmax;
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      // Nbr of itmes in v
      int n=8+rnd.rand()%8;
      vector<int> v;
      int M=6;
      for(int i=0;i<n;i++) v.push_back(rnd.rand()%M-M/2);
      datain["v"] = v;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  typedef bool (*subvector_t)(vector<int> &v1,vector<int> &v2);
  class eval3_t : public eval_base_t {
  public:
    subvector_t F;
    eval3_t() { dumptests=0; F=NULL; ejerc=3; testfile="./sbv.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v1 = data["v1"];
      vector<int> v2 = data["v2"];
      outuser["retval"] = int(F(v1,v2));
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }
    
    void generate_case(randomg_t &rnd,json &datain) {
      int n1=8+rnd.rand()%8, M=3;
      vector<int> v1,v2;
      for (int j=0; j<n1; j++) v1.push_back(rnd.rand()%M);
      int n2=2+rnd.rand()%2;
      for (int j=0; j<n2; j++) v2.push_back(rnd.rand()%M);
      datain["v1"] = v1;
      datain["v2"] = v2;
    }
  };
  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  using Eval = eval_t<eval1_t,occurm_t,
                      eval2_t,subvmax_t,
                      eval3_t,subvector_t>;

}
#undef CSTR

#endif
