// GITVERSION: texstuff-1.3.2-184-gf13ea8a2
#ifndef EVAL_HPP
#define EVAL_HPP
#include <cassert>
#include <cstdlib>
#include "aedtools/evalbase.hpp"
using namespace std;

namespace aed {

  list<int>::iterator string_to_iterator(list<int> &L, string str) {
    if (str=="begin") return L.begin();
    if (str=="end") return L.end();
    assert(str.find("begin+")==0);
    list<int>::iterator it = L.begin();
    advance(it,atoi(str.substr(6).c_str()));
    return it;
  }
  
  string iterator_to_string(list<int> &L, list<int>::iterator it) {
    if (it==L.end()) return "end";
    int n = std::distance(L.begin(),it);
    if (n==0) return "begin";
    return string("begin+")+to_string(n);
  }
  
  list<int>::iterator my_advance(list<int> &L, int n) {
    list<int>::iterator it = L.begin();
    std::advance(it,n);
    return it;
  }
  
  typedef map<int,set<int> > map_t;
  void json2map(json &J,map_t &M) {
    for (json::iterator q = J.begin(); q != J.end(); ++q) {
      int k = (*q)["f"];
      set<int> x = (*q)["xset"];
      M[k] = x;
    }
  }

  void map2json(map_t &M,json &J) {
    auto q = M.begin();
    while (q!=M.end()) {
      json z;
      z["f"] = q->first;
      z["xset"] = q->second;
      J.push_back(z);
      q++;
    }
  }

  typedef int (*mapfun_t)(int);
  // Varias funciones de mapeo
  int sign(int x) { return (x<0? -1 : x==0? 0 : 1); }
  int mod(int x,int n) {
    int z = x%n;
    if (z<0) z += n;
    return z;
  }
  int mod3(int x) { return mod(x,3); }
  int mod5(int x) { return mod(x,5); }
  int absf(int x) { return abs(x); }
  int sq(int x) { return x*x; }
  int sqrti(int x) { return sqrt(abs(x)); }
  
  typedef void (*separate_t)(set<int> &S,mapfun_t f,map<int,set<int> > &f2x);
  class eval1_t : public eval_base_t {
  public:
    separate_t F;
    eval1_t() { dumptests=0; F=NULL; ejerc=1; testfile="./sp.json"; }
    void run_case(json &data,json &outuser) {
      // Read Gin
      list<int> L = data["S"];
      set<int> S; 
      for (auto x:L) S.insert(x);
      // set<int> S = data["S"];
      string sf = data["f"];
#define HOOK(s) sf==#s ? s 
      mapfun_t f = (HOOK(sign)
                    : HOOK(mod3)
                    : HOOK(mod5)
                    : HOOK(absf)
                    : HOOK(sq)
                    : HOOK(sqrti)
                    : NULL);
      assert(f);
      map<int,set<int> > M;
      F(S,f,M);
      // Write M
      map2json(M,outuser);
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }

    void generate_case(randomg_t &rnd,json &datain) {
      int N = 4+rnd.rand()%4, M=N/2;
      set<int> S;
      for (int j=0; j<N; j++) {
        int z = rnd.rand()%(2*M)-M;
        S.insert(z);
      }
      datain["S"] = S;
      int nfun=6;
      int k=rnd.rand()%nfun;
      const char* funcs[]={"sign","mod3","mod5","absf","sq","sqrti"};
      datain["f"] = funcs[k];
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  using Eval = eval_t<eval1_t,separate_t>;

}
#undef CSTR

#endif
